<template>
  <b-modal
    ref="this-modal"
    id="this-modal"
    hide-footer
    :title="isEditClient ? 'Edit Client' : 'Add Client'"
    :size="modalSize"
  >
    <b-container fluid="xl" class="customer-modal">
      <b-row class="customer-modal__info">
        <b-col
          cols="12"
          sm="12"
          md="12"
          :lg="isEditClient ? '9' : '12'"
          :xl="isEditClient ? '9' : '12'"
        >
          <b-row no-gutters class="mt-2 mb-2 customer-modal__info__name">
            <b-col
              cols="3"
              class="
                customer-modal__info__name__label
                customer-modal__info__name__label--center
              "
              >Client Name <span class="asterisk asterisk--red">*</span></b-col
            >
            <b-col cols="9">
              <b-form-input
                class="customer-modal__info__name__input"
                trim
                required
                v-model="clientName"
                @keydown="handleVerifyName($event)"
              ></b-form-input>
            </b-col>
          </b-row>
          <b-row
            no-gutters
            class="mt-2 mb-2 customer-modal__info__client-number"
          >
            <b-col
              cols="3"
              class="
                customer-modal__info__client-number__label
                customer-modal__info__client-number__label--center
              "
              >Client Number</b-col
            >
            <b-col cols="9">
              <b-form-input
                class="customer-modal__info__client-number__input"
                trim
                v-model="memberNumber"
              ></b-form-input>
            </b-col>
          </b-row>
          <b-row
            no-gutters
            class="mt-2 mb-2 customer-modal__info__mobile-phone"
          >
            <b-col
              cols="3"
              class="
                customer-modal__info__mobile-phone__label
                customer-modal__info__mobile-phone__label--center
              "
              >Mobile Number</b-col
            >
            <b-col cols="9">
              <b-form-input
                class="customer-modal__info__mobile-phone__input"
                trim
                placeholder="Number Only"
                v-model="mobileNumber"
                @keydown="handleVerifyPhone($event)"
              ></b-form-input>
            </b-col>
          </b-row>
          <b-row
            no-gutters
            class="mt-2 mb-2 mt-2 mb-2 customer-modal__info__sex"
          >
            <b-col
              cols="3"
              class="
                customer-modal__info__sex__label
                customer-modal__info__sex__label--center
              "
              >Sex</b-col
            >
            <b-col cols="9">
              <b-form-group
                v-slot="{ ariaDescribedby }"
                class="customer-modal__info__sex__radio"
              >
                <b-form-radio-group
                  id="radio-group-1"
                  :options="sexOptions"
                  :aria-describedby="ariaDescribedby"
                  name="radio-options"
                  v-model="clientSex"
                ></b-form-radio-group>
              </b-form-group>
            </b-col>
          </b-row>
          <b-row
            no-gutters
            class="mt-2 mb-2 customer-modal__info__client-group"
          >
            <b-col
              cols="3"
              class="
                customer-modal__info__client-group__label
                customer-modal__info__client-group__label--center
              "
              >Client Group</b-col
            >
            <b-col cols="9">
              <b-form-select
                v-model="clientGroupName"
                :options="clientGroupOptions"
                size="sm"
                class="customer-modal__info__client-group__select"
              >
                <template #first>
                  <b-form-select-option :value="null" disabled selected
                    >Selected</b-form-select-option
                  >
                </template>
              </b-form-select>
            </b-col>
          </b-row>
          <b-row
            no-gutters
            class="mt-2 mb-2 customer-modal__info__register-date"
          >
            <b-col
              cols="3"
              class="
                customer-modal__info__register-date__label
                customer-modal__info__register-date__label--center
              "
              >Registered Date <span style="color: red">*</span></b-col
            >
            <b-col cols="9">
              <b-form-datepicker
                placeholder="MM-DD-YYYY"
                id="datepicker-sm"
                size="sm"
                locale="en"
                class="customer-modal__info__register-date__datepicker"
                :date-format-options="{
                  year: 'numeric',
                  month: '2-digit',
                  day: '2-digit',
                }"
                required
                v-model="registeredDate"
              ></b-form-datepicker>
            </b-col>
            <!-- <b-col cols="4"></b-col> -->
          </b-row>
        </b-col>
        <b-col cols="12" sm="12" md="12" lg="3" xl="3" :hidden="!isEditClient">
          <b-img
            center
            v-if="imageUrl"
            :src="imageUrl"
            alt="Center image"
            @click="openImageModal()"
            class="avatar"
          ></b-img>
          <div v-else class="avatar-frame" @click="openImageModal()">
            Click here to upload avatar
          </div>
        </b-col>
      </b-row>
      <b-row v-if="warning" class="customer-modal__warning">
        <b-col>
          Information is invalid
          <br />
          Name must have character, can contain whitespace, number and can't
          have specific character. For example: !, @, ...
          <br />
          Mobile Number have at most 10 digit, only contain number
        </b-col>
      </b-row>
      <b-row class="customer-modal__btn customer-modal__btn--center">
        <b-button
          variant="primary"
          class="ml-1 mr-1 mt-1 mb-1 customer-modal__btn__save"
          @click="handleUserInfo()"
          >Save</b-button
        >
        <b-button
          variant="primary"
          class="ml-1 mr-1 mt-1 mb-1 customer-modal__btn__delete"
          v-if="isEditClient"
          @click="handleDeleteClient"
          >Delete</b-button
        >
        <b-button
          variant="primary"
          class="ml-1 mr-1 mt-1 mb-1 customer-modal__btn__cancel"
          @click="closeModal"
          >Cancel</b-button
        >
      </b-row>
    </b-container>
    <b-modal
      ref="image-modal"
      id="image-modal"
      hide-footer
      title="Image Register"
      size="md"
      class="upload-avatar-modal"
    >
      <div class="container upload-avatar-modal__no-image" v-if="!imageUrl">
        <div class="row mt-3 mb-3">
          <div class="col-12 upload-avatar-modal__no-image__first-label">
            Register Client Image
          </div>
        </div>
        <div class="row mt-3 mb-3">
          <div class="col-12 upload-avatar-modal__no-image__second-label">
            - Filename extension only png, jpeg, jpg can register
          </div>
        </div>
        <div class="row mt-3 mb-3">
          <div class="col-8">
            <b-form-input v-model="imageFileName"></b-form-input>
          </div>
          <div class="col-4">
            <button class="btn btn-primary" @click="$refs.avatar.click()">
              Search Image
            </button>
          </div>
        </div>
        <input type="file" ref="avatar" @change="uploadImageProcess" hidden />
        <div class="row mt-3 mb-3">
          <span style="color: red">{{ imageWarningText }}</span>
        </div>
        <div class="row mt-3 mb-3">
          <div class="col-12 text-center">
            <b-button
              variant="primary ml-2 mr-2 mt-2 mb-2"
              class="upload-avatar-modal__no-image__save-btn"
              @click="handleSaveAvatar()"
              >Save</b-button
            >
            <b-button
              variant="primary ml-2 mr-2 mt-2 mb-2"
              class="upload-avatar-modal__no-image__cancel-btn"
              @click="closeImageModal()"
              >Cancel</b-button
            >
          </div>
        </div>
      </div>
      <div class="container upload-avatar-modal__have-image" v-else>
        <div class="row">
          <div class="col-12 upload-avatar-modal__have-image__image-frame">
            <img
              class="avatar-uploaded avatar-uploaded--w-100"
              :src="imageUrl"
            />
          </div>
        </div>
        <div class="row mt-3 mb-3">
          <div class="col-12 text-center">
            <b-button
              variant="primary ml-2 mr-2 mt-2 mb-2"
              class="upload-avatar-modal__have-image__image-frame__delete-btn"
              @click="handleDeleteAvatar()"
              >Delete</b-button
            >
            <b-button
              variant="primary ml-2 mr-2 mt-2 mb-2"
              class="upload-avatar-modal__have-image__image-frame__cancel-btn"
              @click="closeImageModal()"
              >Cancel</b-button
            >
          </div>
        </div>
      </div>
    </b-modal>
    <AlertDeleteModal
      ref="AlertDeleteModal"
      @close-modal="closeModal"
      @get-client-info="getClientInfoAfterDelete"
    />
  </b-modal>
</template>

<script>
// import { defineComponent } from "@vue/composition-api";
// import Constant from './../Constant.js'
import "./CustomModal.scss";
import * as api from "./../../apis/api";
import * as constant from "../../libs/Constant.js";
import AlertDeleteModal from "../AlertDeleteModal/AlertDeleteModal.vue";

export default {
  constant,
  name: "CustomModal",
  components: {
    AlertDeleteModal,
  },
  props: {
    modalSize: {
      type: String,
      default: "xl",
    },
    isEditClient: {
      type: Boolean,
      // default: false,
    },
  },
  methods: {
    getClientInfoAfterDelete() {
      this.$emit("get-client-info");
    },
    async openModal(data = null) {
      if (this.isEditClient) {
        var shopId = sessionStorage.getItem("shopId");
        this.clientId = data.item.clientId;
        this.memberNumber = data.item.memberNumber;
        var clientInfo = await api.postAPIs(constant.SPECIFIC_CILENT_API, {
          clientId: data.item.clientId,
          shopId: shopId,
        });
        if (clientInfo.status === 200 && clientInfo?.data?.result) {
          this.clientName = clientInfo.data.result.clientName;
          this.mobileNumber = clientInfo.data.result.mobileNumber;
          this.clientSex = clientInfo.data.result.sex;
          this.clientGroupName = clientInfo.data.result.clientGroupName;
          this.clientGroupId = clientInfo.data.result.clientGroupId;
          this.memberNumber = clientInfo.data.result.memberNumber;
          this.registeredDate = this.getDay(
            clientInfo.data.result.clientInputDateTimeTS * 1000
          );
          this.clientInputDateTimeTS = clientInfo.data.result.registrationDate
            ? clientInfo.data.result.registrationDate.clientInputDateTimeTS
            : null;
          this.imageUrl = clientInfo.data.result.imageName
            ? constant.AVATAR_URL(shopId, clientInfo.data.result.imageName)
            : "";
          this.clientImageId = clientInfo.data.result.clientImageId;
        }
      } else {
        var responseNextMemberNumber = await api.postAPIs(
          constant.NEXT_MEMBER_NUMBER_API,
          {
            shopId: Number(sessionStorage.getItem("shopId")),
          },
          {
            "access-control-allow-headers":
              "Access-Control-Allow-Methods, Access-Control-Allow-Origin, Origin, Accept, Content-Type",
          }
        );
        this.clientName = "";
        this.memberNumber = responseNextMemberNumber?.data?.result || null;
        this.mobileNumber = "";
        this.clientSex = 3;
        this.clientGroupName = null;
        this.clientGroupId = "";
        this.registeredDate = this.getDay(new Date().getTime());
      }
      this.$bvModal.show("this-modal");
    },
    getDay(miliSeconds) {
      var day = new Date(miliSeconds);
      return (
        day.getFullYear() + "-" + (day.getMonth() + 1) + "-" + day.getDate()
      );
    },
    closeModal() {
      this.warning = false;
      this.$bvModal.hide("this-modal");
    },
    openImageModal() {
      this.$bvModal.show("image-modal");
    },
    closeImageModal() {
      this.imageFileName = "";
      this.imageWarningText = "";
      this.$bvModal.hide("image-modal");
    },
    async handleDeleteClient() {
      var payload = {
        clientId: this.clientId,
        country: "VN",
        sessionToken: sessionStorage.getItem("accessToken"),
        shopId: Number(sessionStorage.getItem("shopId")),
        shopLocation: "vi-vn",
      };
      this.$refs.AlertDeleteModal.openAlertDeleteModal(
        "delete-client",
        payload
      );
    },
    handleDeleteAvatar() {
      var payload = {
        shopId: Number(sessionStorage.getItem("shopId")),
        clientImageId: this.clientImageId,
      };
      this.$refs.AlertDeleteModal.openAlertDeleteModal("delete-image", payload);
    },
    async uploadImageProcess(event) {
      this.imageFile = event.target.files[0];
      this.imageFileName = this.imageFile.name; // Fixed
    },
    async handleSaveAvatar() {
      var response = await api.postAPIs(
        constant.SET_IMAGE_API,
        {
          shopId: Number(sessionStorage.getItem("shopId")),
          clientId: this.clientId,
          fomrFile: this.imageFile,
          countryCode: "VN",
        },
        {
          "Content-Type": "multipart/form-data",
          "access-control-allow-headers":
            "Access-Control-Allow-Methods, Access-Control-Allow-Origin, Origin, Accept, Content-Type",
        }
      );
      if (
        response.status == 200 &&
        response?.data?.isOK &&
        response?.data?.result?.imageName
      ) {
        this.imageUrl = constant.AVATAR_URL(
          Number(sessionStorage.getItem("shopId")),
          response.data.result.imageName
        );
        this.imageFileName = "";
        this.closeImageModal();
      } else {
        this.imageWarningText = response.data.errorMessages[0].errorMessage;
      }
    },
    convertToTimeStamp(myDate) {
      var myDateSplit = myDate.split("-"); // Year - Month - Day
      return (
        new Date(
          myDateSplit[1] + "-" + myDateSplit[2] + "-" + myDateSplit[0]
        ).getTime() / 1000
      );
    },
    formatPhoneNumber(phoneNumber) {
      return phoneNumber.replace(/(\d{4})(\d{3})(\d{3})/, "$1.$2.$3");
    },
    async handleUserInfo() {
      if (this.clientName.trim() == "") {
        //  Remove || !this.formatPhoneNumber(this.mobileNumber))
        this.warning = true;
        return;
      }
      var response;
      if (this.isEditClient) {
        response = await api.putAPIs(
          constant.EDIT_CLIENT_INFO_API,
          {
            address1: null,
            address2: null,
            allowedMessageType: 1,
            birthDD: "0",
            birthMonth: "0",
            birthYear: "0",
            birthdayType: 1,
            clientGroupId: this.clientGroupId,
            clientGroupName: this.clientGroupName,
            clientId: this.clientId,
            clientInputDateTimeTS: this.convertToTimeStamp(this.registeredDate),
            clientName: this.clientName,
            clientRatingId: null,
            clientRatingName: null,
            clientReferralSourceId: null,
            clientReferralSourceName: null,
            country: "VN",
            editedDateTimeTS: Math.round(new Date().getTime() / 1000),
            email: null,
            memberNumber: this.memberNumber,
            memberType: 1,
            mobileNumber: this.mobileNumber,
            mobileNumber2: null,
            notes: null,
            phoneNumber: null,
            postcode: null,
            preferredStaffId: 14929,
            preferredStaffName: "Master",
            recommenderId: null,
            sessionToken: sessionStorage.getItem("accessToken"),
            sex: this.clientSex,
            shopId: Number(sessionStorage.getItem("shopId")),
            shopLocation: "vi-vn",
          },
          {
            "access-control-allow-headers":
              "Access-Control-Allow-Methods, Access-Control-Allow-Origin, Origin, Accept, Content-Type",
          }
        );
        if (
          response.status === 200 &&
          response?.data?.isOK &&
          response?.data?.result
        ) {
          this.closeModal();
          this.$emit("get-client-info");
        }
      } else {
        let defaultDate = new Date().getTime() / 1000;
        response = await api.postAPIs(constant.ADD_CLIENT_API, {
            address1: null,
            address2: null,
            allowedMessageType: 1,
            birthDD: "0",
            birthMonth: "0",
            birthYear: "0",
            birthdayType: 1,
            clientGroupId: this.clientGroupId,
            clientGroupName: this.clientGroupName,
            clientInputDateTimeTS: this.registeredDate
              ? this.convertToTimeStamp(this.registeredDate)
              : defaultDate,
            clientName: this.clientName,
            clientRatingId: null,
            clientRatingName: null,
            clientReferralSourceId: null,
            clientReferralSourceName: null,
            country: "VN",
            createdDateTimeTS: this.registeredDate
              ? this.convertToTimeStamp(this.registeredDate)
              : defaultDate,
            email: null,
            memberNumber: this.memberNumber,
            memberType: 1,
            mobileNumber: this.mobileNumber,
            mobileNumber2: null,
            notes: null,
            phoneNumber: null,
            postcode: null,
            preferredStaffId: null,
            preferredStaffName: null,
            recommenderId: null,
            sessionToken: sessionStorage.getItem("accessToken"),
            sex: this.clientSex,
            shopId: Number(sessionStorage.getItem("shopId")),
            shopLocation: "vi-vn",
          }, {
            "access-control-allow-headers":
                "Access-Control-Allow-Methods, Access-Control-Allow-Origin, Origin, Accept, Content-Type"
          });
        if (response.status === 200 && response?.data?.result) {
          // Add new user successfully
          this.closeModal();
          this.$emit("get-client-info");
        }
      }
    },
    handleVerifyName(event) {
      var not_allowed = [
        "!",
        "@",
        "#",
        "$",
        "%",
        "^",
        "&",
        "*",
        "(",
        ")",
        "-",
        "+",
        "=",
        "[",
        "]",
        "{",
        "}",
        "\\",
        "|",
        ";",
        ":",
        "'",
        '"',
        "<",
        ",",
        ">",
        ".",
        "?",
        "/",
      ];
      if (not_allowed.includes(event.key) || this.clientName.length >= 30) {
        if (event.key != "Backspace") event.preventDefault();
      }
    },
    handleVerifyPhone(event) {
      console.log(event);
      var allow = [
        "0",
        "1",
        "2",
        "3",
        "4",
        "5",
        "6",
        "7",
        "8",
        "9",
        "Backspace",
      ];
      if (!allow.includes(event.key)) {
        event.preventDefault();
      }
    },
  },
  data() {
    return {
      constant,
      sexOptions: [
        { text: "Male", value: 1 },
        { text: "Female", value: 2 },
      ],
      clientGroupName: null,
      clientGroupId: null,
      clientGroupOptions: [],
      imageUrl: "",
      imageFileName: "",
      imageFile: "",
      clientName: "",
      mobileNumber: "",
      clientSex: null,
      clientGroupObj: {},
      clientId: null,
      memberNumber: null,
      registeredDate: null,
      birthDD: 0,
      birthMonth: 0,
      birthYear: 0,
      clientInputDateTimeTS: null,
      clientImageId: null,
      warning: false,
      imageWarningText: "",
    };
  },
  async mounted() {
    var getClientGroup = await api.postAPIs(constant.CLIENT_GROUP_API, {
      pageSize: 100,
      pageNumber: 1,
      shopId: Number(sessionStorage.getItem("shopId")),
      status: 1,
    });
    if (getClientGroup.status === 200 && getClientGroup?.data?.result?.items) {
      let items = getClientGroup.data.result.items;
      for (var i = 0; i < items.length; i++) {
        this.clientGroupOptions.push({
          text: items[i].itemName,
          value: items[i].itemName,
        });
        this.clientGroupObj[items[i].itemName] = items[i].clientGroupId;
      }
    }
  },
  watch: {
    clientGroupName(newValue) {
      this.clientGroupId = this.clientGroupObj[newValue];
    },
    registeredDate(newValue) {
      console.log("newValue = ", newValue);
    },
  },
};
</script>

<style lang="scss" scoped>
</style>